=encoding utf8

=head1 NAME

Mail::Transport::Mailx - transmit messages using external mailx program

=head1 INHERITANCE

 Mail::Transport::Mailx
   is a Mail::Transport::Send
   is a Mail::Transport
   is a Mail::Reporter

=head1 SYNOPSIS

  my $sender = Mail::Transport::Mailx->new(...);
  $sender->send($message);

=head1 DESCRIPTION

Implements mail transport using the external programs C<'mailx'>,
C<Mail>, or C<'mail'>.  When instantiated, the mailer will look for
any of these binaries in specific system directories, and the first
program found is taken.

B<WARNING: There are many security issues with mail and mailx. DO NOT USE
these commands to send messages which contains data derived from any
external source!!!>

Under Linux, freebsd, and bsdos the C<mail>, C<Mail>, and C<mailx> names are
just links to the same binary.  The implementation is very primitive, pre-MIME
standard,  what may cause many headers to be lost.  For these platforms (and
probably for other platforms as well), you can better not use this transport
mechanism.

Extends L<"DESCRIPTION" in Mail::Transport::Send|Mail::Transport::Send/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Transport::Send|Mail::Transport::Send/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Transport::Send|Mail::Transport::Send/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

 -Option    --Defined in     --Default
  executable  Mail::Transport  undef
  hostname    Mail::Transport  'localhost'
  interval    Mail::Transport  30
  password    Mail::Transport  undef
  port        Mail::Transport  undef
  proxy       Mail::Transport  undef
  retry       Mail::Transport  <unlimited>
  style                        <autodetect>
  timeout     Mail::Transport  120
  username    Mail::Transport  undef
  via         Mail::Transport  'mailx'

=over 2

=item executable => $file

=item hostname => $host|\@hosts

=item interval => $span

=item password => $password

=item port => $port

=item proxy => $path

=item retry => $count|undef

=item style => 'BSD'|'RFC822'

There are two version of the C<mail> program.  The newest accepts
RFC822 messages, and automagically collect information about where
the message is to be send to.  The BSD style mail command predates
MIME, and expects lines which start with a C<'~'> (tilde) to specify
destinations and such.  This field is autodetect, however on some
platforms both versions of C<mail> can live (like various Linux
distributions).

=item timeout => $span

=item username => $username

=item via => CLASS|$name

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Transport::Send|Mail::Transport::Send/"Attributes">.

=head2 Sending mail

Extends L<"Sending mail" in Mail::Transport::Send|Mail::Transport::Send/"Sending mail">.

=over 4

=item $obj-E<gt>B<destinations>( $message, [$address|\@addresses] )

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<putContent>($message, $fh, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<send>($message, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<trySend>($message, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=back

=head2 Server connection

Extends L<"Server connection" in Mail::Transport::Send|Mail::Transport::Send/"Server connection">.

=over 4

=item $obj-E<gt>B<findBinary>( $name, [@directories] )

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<remoteHost>()

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<retry>()

Inherited, see L<Mail::Transport/"Server connection">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Transport::Send|Mail::Transport::Send/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Transport::Send|Mail::Transport::Send/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: cannot find binary of mailx.

Cast by C<new()>

=item Fault: cannot open pipe to $program: $!

Cast by C<trySend()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: message has no destination.

It was not possible to figure-out where the message is intended to go to.
Cast by C<destinations()>

=item Warning: resent group does not specify a destination.

The message which is sent is the result of a bounce (for instance
created with L<Mail::Message::bounce()|Mail::Message::Construct::Bounce/"Constructing a message">), and therefore starts with a
C<Received> header field.  With the C<bounce>, the new destination(s)
of the message are given, which should be included as C<Resent-To>,
C<Resent-Cc>, and C<Resent-Bcc>.

The C<To>, C<Cc>, and C<Bcc> header information is only used if no
C<Received> was found.  That seems to be the best explanation of the RFC.

As alternative, you may also specify the C<to> option to some of the senders
(for instance L<Mail::Transport::SMTP::send(to)|Mail::Transport::Send/"Sending mail"> to overrule any information
found in the message itself about the destination.
Cast by C<destinations()>

=item Fault: sending via mailx mailer $program failed: $!

Mailx (in some shape: there are many different implementations) did start
accepting messages, but did not succeed sending it.
Cast by C<trySend()>

=back

=head1 SEE ALSO

This module is part of Mail-Transport version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

